from ..config import *


def patch_core_build():
    logger.info("Patching core")
    with open(core_path, 'r', encoding="utf-8") as file:
        core = file.read()
    logger.info(" - core loaded")
    logger.info(" - unpack values...")
    ver_data_index = core.find("'", core.find("__version__ = "))
    major, minor, patch = core[ver_data_index + 1:core.find("'", ver_data_index + 1)].split('.')

    build_index_start = core.find("__build__ = ")
    build_index_stop = core.find("\n", build_index_start)
    build_i = int(core[build_index_start + 12:build_index_stop])

    logger.info(f" - current version: {major}.{minor}.{patch}.{build_i}")
    build_i += 1
    logger.info(f" - patched version: {major}.{minor}.{patch}.{build_i}")

    logger.info(" - patching")
    core = core[:build_index_start] + f"__build__ = {build_i}" + core[build_index_stop:]
    with open(core_path, 'w', encoding="utf-8") as file:
        file.write(core)
    logger.info(" - saved")
    logger.info("Ready")
    return major, minor, patch, build_i


if __name__ == '__main__':
    patch_core_build()
